import { ITileParserCFG } from '@antv/l7-core';
import { ITileBand, SourceTile, TileLoadParams } from '@antv/l7-utils';
import { IBandsOperation, IRasterFormat } from '../../interface';
/**
 * 用于获取 raster data 的瓦片，如 tiff、lerc、dem 等
 * 支持多文件模式
 * @param url
 * @param tileParams
 * @param tile
 * @param rasterFormat
 * @returns
 */
export declare const getTileBuffer: (url: string | string[] | ITileBand[], tileParams: TileLoadParams, tile: SourceTile, rasterFormat: IRasterFormat, operation?: IBandsOperation) => Promise<HTMLImageElement | ImageBitmap>;
/**
 * 获取图片格式的文件 jpg、png 等
 * @param url
 * @param tileParams
 * @param tile
 * @returns
 */
export declare const getTileImage: (url: string | string[], tileParams: TileLoadParams, tile: SourceTile, cfg: Partial<ITileParserCFG>) => Promise<HTMLImageElement | ImageBitmap>;
export declare const defaultFormat: () => {
    rasterData: Uint8Array;
    width: number;
    height: number;
};
