var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/bandOperation/math.ts
var math_exports = {};
__export(math_exports, {
  calculate: () => calculate,
  calculateExpress: () => calculateExpress,
  formatExpress: () => formatExpress,
  mathematical: () => mathematical,
  spellExpress: () => spellExpress
});
module.exports = __toCommonJS(math_exports);
function mathematical(symbol, n1, n2) {
  switch (symbol) {
    case "+":
      return n1 + n2;
    case "-":
      return n1 - n2;
    case "*":
      return n1 * n2;
    case "/":
      return n1 / n2;
    case "%":
      return n1 % n2;
    case "^":
      return Math.pow(n1, n2);
    case "abs":
      return Math.abs(n1);
    case "floor":
      return Math.floor(n1);
    case "round":
      return Math.round(n1);
    case "ceil":
      return Math.ceil(n1);
    case "sin":
      return Math.sin(n1);
    case "cos":
      return Math.cos(n1);
    case "atan":
      return n2 === -1 ? Math.atan(n1) : Math.atan2(n1, n2);
    case "min":
      return Math.min(n1, n2);
    case "max":
      return Math.max(n1, n2);
    case "log10":
      return Math.log(n1);
    case "log2":
      return Math.log2(n1);
    default:
      console.warn("Calculate symbol err! Return default 0");
      return 0;
  }
}
function calculate(express, bandsData) {
  const { width, height } = bandsData[0];
  const dataArray = bandsData.map((band) => band.rasterData);
  const length = width * height;
  const rasterData = [];
  const originExp = JSON.stringify(express);
  for (let i = 0; i < length; i++) {
    const exp = JSON.parse(originExp);
    const expResult = spellExpress(exp, dataArray, i);
    if (typeof expResult === "number") {
      rasterData.push(expResult);
    } else {
      const result = calculateExpress(exp);
      rasterData.push(result);
    }
  }
  return rasterData;
}
function spellExpress(express, dataArray, index) {
  if (express.length === 2 && express[0] === "band" && typeof express[1] === "number") {
    try {
      return dataArray[express[1]][index];
    } catch (err) {
      console.warn("Raster Data err!");
      return 0;
    }
  }
  express.map((e, i) => {
    if (Array.isArray(e) && e.length > 0) {
      switch (e[0]) {
        case "band":
          try {
            express[i] = dataArray[e[1]][index];
          } catch (err) {
            console.warn("Raster Data err!");
            express[i] = 0;
          }
          break;
        default:
          spellExpress(e, dataArray, index);
      }
    }
  });
}
function formatExpress(express) {
  const [symbol1, symbol2 = -1, symbol3 = -1] = express;
  if (symbol1 === void 0) {
    console.warn("Express err!");
    return ["+", 0, 0];
  }
  const symbol = symbol1.replace(/\s+/g, "");
  return [symbol, symbol2, symbol3];
}
function calculateExpress(express) {
  const formatExp = formatExpress(express);
  const str = formatExp[0];
  let left = formatExp[1];
  let right = formatExp[2];
  if (Array.isArray(left)) {
    left = calculateExpress(express[1]);
  }
  if (Array.isArray(right)) {
    right = calculateExpress(express[2]);
  }
  return mathematical(str, left, right);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  calculate,
  calculateExpress,
  formatExpress,
  mathematical,
  spellExpress
});
